diff --git a/test/acceptance/prompt_installer_test.rb b/test/acceptance/prompt_installer_test.rb
new file mode 100644
index 00000000..7922f5a5
--- /dev/null
+++ b/test/acceptance/prompt_installer_test.rb
@@ -0,0 +1,9 @@
+require "test_helper"
+
+class PromptInstallerAcceptanceTest < Minitest::Test
+  def test_one_prompt_names_all_agents_and_three_consent_boundaries
+    prompt = File.read(File.expand_path("../../docs/install-with-agent.md", __dir__))
+    %w[Claude Codex Pi Homebrew hive-bin].each { |value| assert_includes prompt, value }
+    assert_operator prompt.scan(/ask .*approval|Ask /i).size, :>=, 3
+  end
+end
diff --git a/test/acceptance/release_qualification_test.rb b/test/acceptance/release_qualification_test.rb
new file mode 100644
index 00000000..ef8984a7
--- /dev/null
+++ b/test/acceptance/release_qualification_test.rb
@@ -0,0 +1,45 @@
+require "test_helper"
+
+class ReleaseQualificationTest < Minitest::Test
+  ROOT = File.expand_path("../..", __dir__)
+
+  def test_release_workflow_is_two_phase_and_distribution_suite_is_blocking
+    workflow = File.read(File.join(ROOT, ".github/workflows/release.yml"))
+    build_workflow = File.read(File.join(ROOT, ".github/workflows/build-release.yml"))
+    install_smoke = File.read(File.join(ROOT, ".github/workflows/install-smoke.yml"))
+    assert_match(/needs:.*build/m, workflow)
+    assert_match(/gh release create/, workflow)
+    assert_match(/needs:.*release/m, workflow)
+    assert_includes workflow, "rake distribution"
+    assert_includes workflow, "tier1-shell"
+    assert_includes workflow, "tier1-homebrew"
+    assert_includes workflow, "tier1-aur"
+    assert_includes workflow, "publish-skills"
+    assert_includes workflow, "claude plugin marketplace add"
+    assert_includes workflow, "claude plugin install"
+    assert_includes workflow, "codex plugin add"
+    assert_includes workflow, "pi install"
+    assert_includes workflow, "subject-path: dist/hive-*.tar.gz"
+    publisher = File.read(File.join(ROOT, "scripts/publish-packages"))
+    assert_includes publisher, "scripts/verify-release"
+    assert_includes publisher, "--remote"
+    assert_includes workflow, "SHA256:RFzBCUItH9LZS0cKB5UE6ceAYhBD5C8GeOBip8Z11+4"
+    assert_includes build_workflow, "attestations: write"
+    refute_includes workflow, "ssh-keyscan aur.archlinux.org >>"
+    refute_match(/if:.*HOMEBREW_TAP_REPOSITORY.*AUR_REPOSITORY/, workflow)
+    refute_includes build_workflow, "subject-path: build/hive-"
+    assert_includes install_smoke, "homebrew:"
+    refute_includes install_smoke, "base-devel git ruby"
+    refute_includes install_smoke, "pacman -Rns"
+  end
+
+  def test_public_docs_name_collision_consent_and_preserved_paths
+    readme = File.read(File.join(ROOT, "README.md"))
+    uninstall = File.read(File.join(ROOT, "docs/uninstall.md"))
+    assert_includes readme, "Homebrew"
+    assert_includes readme, "`hv`"
+    assert_includes uninstall, "preserved"
+    assert_includes uninstall, "agent skills"
+    assert_includes uninstall, "completed"
+  end
+end
diff --git a/test/acceptance/ubuntu_shell_test.rb b/test/acceptance/ubuntu_shell_test.rb
new file mode 100644
index 00000000..485ae1e1
--- /dev/null
+++ b/test/acceptance/ubuntu_shell_test.rb
@@ -0,0 +1,11 @@
+require "test_helper"
+
+class UbuntuShellAcceptanceTest < Minitest::Test
+  def test_installer_requires_manifest_digest_and_version_check
+    installer = File.read(File.expand_path("../../scripts/install.sh", __dir__))
+    assert_includes installer, "release-manifest.json"
+    assert_match(/sha256sum|shasum/, installer)
+    assert_includes installer, "--version"
+    refute_match(/sudo/, installer)
+  end
+end
diff --git a/test/acceptance/uninstall_preserves_work_test.rb b/test/acceptance/uninstall_preserves_work_test.rb
new file mode 100644
index 00000000..612af687
--- /dev/null
+++ b/test/acceptance/uninstall_preserves_work_test.rb
@@ -0,0 +1,38 @@
+require "test_helper"
+require "digest"
+require "hive/commands/uninstall"
+
+class UninstallPreservesWorkTest < Minitest::Test
+  include HiveTestHelper
+
+  def test_purge_boundary_preserves_modified_unknown_state_and_skills
+    with_tmp_dir do |root|
+      FileUtils.mkdir_p(File.join(root, ".hive"))
+      generated = File.join(root, ".hive/generated")
+      modified = File.join(root, ".hive/modified")
+      unknown = File.join(root, ".hive/unknown")
+      state = File.join(root, ".hive-state/stages/8-done/task/output")
+      skill = File.join(root, ".agents/skills/hive/SKILL.md")
+      [ generated, modified, unknown, state, skill ].each { |path| FileUtils.mkdir_p(File.dirname(path)) }
+      File.write(generated, "owned")
+      File.write(modified, "changed")
+      File.write(unknown, "unknown")
+      File.write(state, "completed")
+      File.write(skill, "skill")
+      File.write(File.join(root, ".hive/ownership.yml"), {
+        "version" => 1,
+        "files" => {
+          ".hive/generated" => Digest::SHA256.hexdigest("owned"),
+          ".hive/modified" => Digest::SHA256.hexdigest("original")
+        }
+      }.to_yaml)
+
+      Hive::Commands::Uninstall.cleanup_project(root)
+      refute File.exist?(generated)
+      assert File.exist?(modified)
+      assert File.exist?(unknown)
+      assert File.exist?(state)
+      assert File.exist?(skill)
+    end
+  end
+end
diff --git a/test/install/agent_prompt_contract_test.rb b/test/install/agent_prompt_contract_test.rb
new file mode 100644
index 00000000..ac550dc8
--- /dev/null
+++ b/test/install/agent_prompt_contract_test.rb
@@ -0,0 +1,37 @@
+require "test_helper"
+require "json"
+
+class AgentPromptContractTest < Minitest::Test
+  ROOT = File.expand_path("../..", __dir__)
+
+  def test_prompt_covers_channels_consent_and_collision_without_private_writes
+    prompt = File.read(File.join(ROOT, "docs/install-with-agent.md"))
+    assert_includes prompt, "uname -s"
+    assert_includes prompt, "Homebrew"
+    assert_includes prompt, "paru"
+    assert_includes prompt, "checksum-verifying Hive shell"
+    assert_includes prompt, "ivankuznetsov/hive"
+    assert_includes prompt, "ivankuznetsov/hive-skills"
+    assert_includes prompt, "0.1.0"
+    assert_includes prompt, "ask for approval"
+    assert_includes prompt, "use `hv`"
+    assert_match(/confirm the\s+> absolute Git project root/, prompt)
+    refute_match(%r{(?:~|\$HOME)/\.(?:claude|codex|pi)}, prompt)
+  end
+
+  def test_skill_copy_and_marketplace_versions_match
+    canonical = File.read(File.join(ROOT, "hive-skills/skills/hive/SKILL.md"))
+    packaged = File.read(File.join(ROOT, "hive-skills/plugins/hive-skills/skills/hive/SKILL.md"))
+    assert_equal canonical, packaged
+
+    codex = JSON.parse(File.read(File.join(ROOT, "hive-skills/plugins/hive-skills/.codex-plugin/plugin.json")))
+    claude = JSON.parse(File.read(File.join(ROOT, "hive-skills/plugins/hive-skills/.claude-plugin/plugin.json")))
+    pi = JSON.parse(File.read(File.join(ROOT, "hive-skills/package.json")))
+    adapters = JSON.parse(File.read(File.join(ROOT, "hive-skills/marketplaces/adapters.json")))
+    assert_equal [ "0.1.0" ], [ codex["version"], claude["version"], pi["version"], adapters["version"] ].uniq
+    assert_equal Hive::VERSION, adapters["version"]
+    adapters.fetch("adapters").each_value do |commands|
+      commands.each { |command| refute_includes command, "<org>" }
+    end
+  end
+end
diff --git a/test/install/package_render_test.rb b/test/install/package_render_test.rb
new file mode 100644
index 00000000..b1accdb8
--- /dev/null
+++ b/test/install/package_render_test.rb
@@ -0,0 +1,66 @@
+require "test_helper"
+require "json"
+require "open3"
+
+class PackageRenderTest < Minitest::Test
+  include HiveTestHelper
+
+  ROOT = File.expand_path("../..", __dir__)
+
+  def test_renders_homebrew_and_aur_from_one_manifest
+    with_tmp_dir do |dir|
+      manifest = File.join(dir, "manifest.json")
+      output = File.join(dir, "packages")
+      File.write(manifest, JSON.generate(
+        "schema_version" => 1,
+        "version" => "0.1.0",
+        "tag" => "v0.1.0",
+        "repository" => "example/hive",
+        "ruby_version" => "3.4.1",
+        "installer_compatibility" => 1,
+        "targets" => [
+          target("darwin-arm64", "mac.tar.gz", "a" * 64),
+          target("linux-x86_64", "linux.tar.gz", "b" * 64)
+        ]
+      ))
+      _out, err, status = Open3.capture3(
+        File.join(ROOT, "scripts/render-packages"),
+        "--manifest", manifest,
+        "--output-dir", output
+      )
+      assert status.success?, err
+      formula = File.read(File.join(output, "homebrew/Formula/hive.rb"))
+      pkgbuild = File.read(File.join(output, "aur/PKGBUILD"))
+      install_hook = File.read(File.join(output, "aur/hive-bin.install"))
+      assert_includes formula, "sha256 \"#{'a' * 64}\""
+      assert_includes pkgbuild, "sha256sums_x86_64=('#{'b' * 64}')"
+      assert_includes pkgbuild, "pkgname=hive-bin"
+      refute_match(/\bruby\b.*depends/, pkgbuild)
+      assert_includes formula, "prefix_hive.realpath == prefix_hv.realpath"
+      assert_includes formula, "File.identical?(candidate, prefix_hive)"
+      assert_includes formula, "command_name: \#{selected_command}"
+      assert_includes formula, "package: example/hive/hive"
+      assert_includes formula, "Optional Hive dependency missing"
+      assert_includes pkgbuild, "managed_files:"
+      assert_includes install_hook, "pre_upgrade()"
+      assert_includes install_hook, "s/^command_name: hive$/command_name: hv/"
+      _out, syntax_error, syntax_status = Open3.capture3("bash", "-n", File.join(output, "aur/PKGBUILD"))
+      assert syntax_status.success?, syntax_error
+      _out, syntax_error, syntax_status = Open3.capture3("ruby", "-c", File.join(output, "homebrew/Formula/hive.rb"))
+      assert syntax_status.success?, syntax_error
+    end
+  end
+
+  private
+
+  def target(name, asset, sha)
+    {
+      "target" => name,
+      "asset" => asset,
+      "url" => "https://example.test/#{asset}",
+      "sha256" => sha,
+      "size" => 10,
+      "minimum_os" => "test"
+    }
+  end
+end
diff --git a/test/install/shell_installer.bats b/test/install/shell_installer.bats
new file mode 100755
index 00000000..35b47490
--- /dev/null
+++ b/test/install/shell_installer.bats
@@ -0,0 +1,33 @@
+#!/usr/bin/env bats
+
+setup() {
+  export TEST_ROOT="${BATS_TEST_TMPDIR}/case"
+  export HOME="${TEST_ROOT}/home"
+  export XDG_DATA_HOME="${TEST_ROOT}/data"
+  export HIVE_BIN_DIR="${TEST_ROOT}/bin"
+  export HIVE_INSTALL_BASE_URL="file://${TEST_ROOT}/releases"
+  mkdir -p "${HOME}" "${TEST_ROOT}/build"
+  printf '#!/bin/sh\nprintf "0.1.0\\n"\n' > "${TEST_ROOT}/build/hive-linux-x86_64"
+  chmod +x "${TEST_ROOT}/build/hive-linux-x86_64"
+  HIVE_RELEASE_REPOSITORY=example/hive \
+    "${BATS_TEST_DIRNAME}/../../scripts/package-release" \
+      --version 0.1.0 --build-dir "${TEST_ROOT}/build" --dist-dir "${TEST_ROOT}/releases/v0.1.0"
+  cp "${BATS_TEST_DIRNAME}/../../scripts/install.sh" "${TEST_ROOT}/releases/v0.1.0/install.sh"
+  cp "${BATS_TEST_DIRNAME}/../../scripts/uninstall-shell.sh" "${TEST_ROOT}/releases/v0.1.0/uninstall-shell.sh"
+}
+
+@test "installs and verifies the linux artifact" {
+  run "${BATS_TEST_DIRNAME}/../../scripts/install.sh" --version 0.1.0 --yes
+  [ "$status" -eq 0 ]
+  [ "$("${HIVE_BIN_DIR}/hv" --version)" = "0.1.0" ]
+  [ -L "${HIVE_BIN_DIR}/hive" ]
+}
+
+@test "digest mismatch preserves an existing executable" {
+  mkdir -p "${HIVE_BIN_DIR}"
+  printf 'old\n' > "${HIVE_BIN_DIR}/hv"
+  printf 'tamper' >> "${TEST_ROOT}/releases/v0.1.0/hive-0.1.0-linux-x86_64.tar.gz"
+  run "${BATS_TEST_DIRNAME}/../../scripts/install.sh" --version 0.1.0 --yes
+  [ "$status" -ne 0 ]
+  [ "$(cat "${HIVE_BIN_DIR}/hv")" = "old" ]
+}
diff --git a/test/install/shell_installer_test.rb b/test/install/shell_installer_test.rb
new file mode 100644
index 00000000..e2fda89f
--- /dev/null
+++ b/test/install/shell_installer_test.rb
@@ -0,0 +1,110 @@
+require "test_helper"
+require "digest"
+require "open3"
+
+class ShellInstallerTest < Minitest::Test
+  include HiveTestHelper
+
+  ROOT = File.expand_path("../..", __dir__)
+
+  def test_public_defaults_use_the_canonical_latest_release_and_bounded_downloads
+    installer = File.read(File.join(ROOT, "scripts/install.sh"))
+
+    assert_includes installer, "ivankuznetsov/hive"
+    assert_includes installer, "/releases/latest/download"
+    assert_includes installer, "--connect-timeout 10"
+    assert_includes installer, "--max-time 120"
+    assert_includes installer, "--retry 3"
+    refute_match(/\bsigned (?:release )?manifest\b/i, installer)
+  end
+
+  def test_verified_install_and_uninstall_preserve_state
+    with_tmp_dir do |dir|
+      home = File.join(dir, "home")
+      build = File.join(dir, "build")
+      release = File.join(dir, "releases", "v0.1.0")
+      bin = File.join(dir, "bin")
+      data = File.join(dir, "data")
+      FileUtils.mkdir_p([ home, build, release ])
+      binary = File.join(build, "hive-linux-x86_64")
+      File.write(binary, "#!/bin/sh\nprintf '0.1.0\\n'\n")
+      File.chmod(0o755, binary)
+      package_release(build, release)
+      FileUtils.cp(File.join(ROOT, "scripts/install.sh"), File.join(release, "install.sh"))
+      FileUtils.cp(File.join(ROOT, "scripts/uninstall-shell.sh"), File.join(release, "uninstall-shell.sh"))
+      env = {
+        "HOME" => home,
+        "XDG_DATA_HOME" => data,
+        "HIVE_BIN_DIR" => bin,
+        "HIVE_INSTALL_BASE_URL" => "file://#{File.join(dir, 'releases')}",
+        "PATH" => ENV.fetch("PATH")
+      }
+
+      _out, err, status = Open3.capture3(env, File.join(ROOT, "scripts/install.sh"), "--version", "0.1.0", "--yes")
+      assert status.success?, err
+      assert_equal "0.1.0\n", IO.popen([ File.join(bin, "hv"), "--version" ], &:read)
+      receipt = File.read(File.join(data, "hive/install-receipt.yml"))
+      assert_includes receipt, "installer_sha256:"
+      assert_includes receipt, "uninstaller_sha256:"
+      assert_includes receipt, "executable_sha256:"
+
+      FileUtils.rm_f(File.join(bin, "hive"))
+      File.write(File.join(bin, "hive"), "#!/bin/sh\necho foreign\n")
+      File.chmod(0o755, File.join(bin, "hive"))
+      foreign_digest = Digest::SHA256.file(File.join(bin, "hive")).hexdigest
+      _out, err, status = Open3.capture3(env, File.join(ROOT, "scripts/install.sh"), "--version", "0.1.0", "--yes")
+      assert status.success?, err
+      assert_equal foreign_digest, Digest::SHA256.file(File.join(bin, "hive")).hexdigest
+      assert_includes File.read(File.join(data, "hive/install-receipt.yml")), "command_name: hv"
+
+      FileUtils.mkdir_p(File.join(data, "state"))
+      File.write(File.join(data, "state", "keep"), "work")
+
+      _out, err, status = Open3.capture3(env, File.join(data, "hive/uninstall-shell.sh"), "--yes")
+      assert status.success?, err
+      refute File.exist?(File.join(bin, "hv"))
+      assert File.exist?(File.join(data, "state", "keep"))
+    end
+  end
+
+  def test_tampered_helper_preserves_the_previous_executable
+    with_tmp_dir do |dir|
+      home = File.join(dir, "home")
+      build = File.join(dir, "build")
+      release = File.join(dir, "releases", "v0.1.0")
+      bin = File.join(dir, "bin")
+      FileUtils.mkdir_p([ home, build, release, bin ])
+      binary = File.join(build, "hive-linux-x86_64")
+      File.write(binary, "#!/bin/sh\nprintf '0.1.0\\n'\n")
+      File.chmod(0o755, binary)
+      package_release(build, release)
+      File.write(File.join(bin, "hv"), "previous\n")
+      File.write(File.join(release, "uninstall-shell.sh"), "tampered\n")
+      env = {
+        "HOME" => home,
+        "XDG_DATA_HOME" => File.join(dir, "data"),
+        "HIVE_BIN_DIR" => bin,
+        "HIVE_INSTALL_BASE_URL" => "file://#{File.join(dir, 'releases')}",
+        "PATH" => ENV.fetch("PATH")
+      }
+
+      _out, _err, status = Open3.capture3(env, File.join(ROOT, "scripts/install.sh"), "--version", "0.1.0", "--yes")
+
+      refute status.success?
+      assert_equal "previous\n", File.read(File.join(bin, "hv"))
+    end
+  end
+
+  private
+
+  def package_release(build, release)
+    _out, err, status = Open3.capture3(
+      { "HIVE_RELEASE_REPOSITORY" => "example/hive" },
+      File.join(ROOT, "scripts/package-release"),
+      "--version", "0.1.0",
+      "--build-dir", build,
+      "--dist-dir", release
+    )
+    assert status.success?, err
+  end
+end
diff --git a/test/integration/fixtures/tui-fake-child b/test/integration/fixtures/tui-fake-child
index 3a9fdbd6..11f7a2a3 100755
--- a/test/integration/fixtures/tui-fake-child
+++ b/test/integration/fixtures/tui-fake-child
@@ -7,6 +7,11 @@
 #   HIVE_TUI_FAKE_STDERR=text    print to stderr
 #   HIVE_TUI_FAKE_TRAP_INT=1     trap SIGINT, print marker, exit 130
 #   HIVE_TUI_FAKE_BLOCK=1        sleep until killed (used for SIGINT/SIGTERM tests)
+#   HIVE_TUI_FAKE_PID_FILE=path  append this fixture's PID for targeted cleanup
+
+if [[ -n "$HIVE_TUI_FAKE_PID_FILE" ]]; then
+  printf '%s\n' "$$" >> "$HIVE_TUI_FAKE_PID_FILE"
+fi
 
 if [[ "$HIVE_TUI_FAKE_TRAP_INT" == "1" ]]; then
   trap 'echo "fake-child:caught-SIGINT"; exit 130' INT
diff --git a/test/integration/init_test.rb b/test/integration/init_test.rb
index 0b423861..baa0d36e 100644
--- a/test/integration/init_test.rb
+++ b/test/integration/init_test.rb
@@ -36,6 +36,12 @@ class InitTest < Minitest::Test
 
         projects = Hive::Config.registered_projects
         assert(projects.any? { |p| p["path"] == File.expand_path(dir) })
+        assert_equal false, Hive::Config.load(dir).dig("daemon", "enabled")
+
+        provider_config = YAML.safe_load_file(File.join(ENV.fetch("XDG_CONFIG_HOME"), "hive", "config.yml"))
+        assert_equal "openai", provider_config["provider"]
+        assert_equal "gpt-5", provider_config["model"]
+        assert_equal "env:OPENAI_API_KEY", provider_config["credential_source"]
       end
     end
   end
@@ -113,14 +119,17 @@ class InitTest < Minitest::Test
     end
   end
 
-  def test_double_init_raises_already_initialized_with_exit_2
+  def test_double_init_is_idempotent_and_repairs_missing_scaffold
     with_tmp_global_config do
       with_tmp_git_repo do |dir|
         capture_io { Hive::Commands::Init.new(dir).call }
-        _, err, status = with_captured_exit { Hive::Commands::Init.new(dir).call }
-        assert_equal Hive::ExitCodes::ALREADY_INITIALIZED, status,
-                     "second init must raise Hive::AlreadyInitialized (exit 2), not bare exit"
-        assert_includes err, "already initialized"
+        generated = File.join(dir, ".hive", "settings.yml")
+        File.delete(generated)
+
+        _out, err = capture_io { Hive::Commands::Init.new(dir).call }
+
+        refute_includes err, "already initialized"
+        assert File.file?(generated)
       end
     end
   end
@@ -210,11 +219,11 @@ class InitTest < Minitest::Test
     # triage bias, 9 limit prompts, daemon-enable, confirm. Choose codex
     # for both, safetyist triage, only first + third reviewer, override
     # `plan` budget/timeout, accept the rest (daemon defaults to enabled on
-    # blank, confirm defaults to yes on blank).
+    # blank, provider/model/credential use defaults, confirmation defaults yes).
     inputs = [
       "codex", "2", "1,3", "safetyist",
       "", "30,900", "", "", "", "", "", "", "",
-      "", ""
+      "", "", "", "", ""
     ].join("\n") + "\n"
     with_tmp_global_config do
       with_tmp_git_repo do |dir|
@@ -244,7 +253,7 @@ class InitTest < Minitest::Test
 
   def test_init_with_daemon_disabled_writes_disabled_config
     # Same shape as above but explicitly answer `n` to the daemon prompt.
-    inputs = (([ "" ] * 13) + [ "n", "" ]).join("\n") + "\n"
+    inputs = (([ "" ] * 13) + [ "n", "", "", "", "" ]).join("\n") + "\n"
     with_tmp_global_config do
       with_tmp_git_repo do |dir|
         prompts = make_tty_prompts(inputs)
@@ -259,8 +268,9 @@ class InitTest < Minitest::Test
 
   def test_init_aborts_with_zero_disk_state_when_user_says_n
     # Blank for everything until confirmation; answer `n` at the end.
-    # 14 blanks: planning, dev, reviewers, triage bias, 9 limits, daemon-enable.
-    inputs = (([ "" ] * 14) + [ "n" ]).join("\n") + "\n"
+    # 17 blanks: planning, dev, reviewers, triage bias, 9 limits,
+    # daemon-enable, provider, model, and credential environment.
+    inputs = (([ "" ] * 17) + [ "n" ]).join("\n") + "\n"
     with_tmp_global_config do
       with_tmp_git_repo do |dir|
         prompts = make_tty_prompts(inputs)
@@ -301,11 +311,7 @@ class InitTest < Minitest::Test
         input.define_singleton_method(:tty?) { true }
         prompts = Hive::Commands::Init::Prompts.new(input: input, output: StringIO.new)
 
-        _, err, status = with_captured_exit do
-          Hive::Commands::Init.new(dir, prompts: prompts).call
-        end
-        assert_equal Hive::ExitCodes::ALREADY_INITIALIZED, status
-        assert_includes err, "already initialized"
+        capture_io { Hive::Commands::Init.new(dir, prompts: prompts).call }
         assert_equal "crash-on-this-input", input.gets&.chomp,
                      "no input should have been consumed by the second init"
       end
diff --git a/test/integration/packaged_entrypoint_test.rb b/test/integration/packaged_entrypoint_test.rb
new file mode 100644
index 00000000..ecaaaa3d
--- /dev/null
+++ b/test/integration/packaged_entrypoint_test.rb
@@ -0,0 +1,16 @@
+require "test_helper"
+require "open3"
+
+class PackagedEntrypointTest < Minitest::Test
+  def test_version_works_outside_checkout
+    root = File.expand_path("../..", __dir__)
+    out, err, status = Open3.capture3(
+      { "HIVE_RESOURCE_ROOT" => root },
+      File.join(root, "bin", "hive"),
+      "--version",
+      chdir: "/tmp"
+    )
+    assert status.success?, err
+    assert_equal "#{Hive::VERSION}\n", out
+  end
+end
diff --git a/test/integration/tui_subprocess_test.rb b/test/integration/tui_subprocess_test.rb
index 34ad39c3..2ee60de6 100644
--- a/test/integration/tui_subprocess_test.rb
+++ b/test/integration/tui_subprocess_test.rb
@@ -24,12 +24,12 @@ class TuiSubprocessTest < Minitest::Test
     # registry populated. Re-zeroing it keeps tests order-independent.
     Hive::Tui::SubprocessRegistry.clear
     %w[HIVE_TUI_FAKE_EXIT HIVE_TUI_FAKE_STDOUT HIVE_TUI_FAKE_STDERR
-       HIVE_TUI_FAKE_TRAP_INT HIVE_TUI_FAKE_BLOCK].each { |k| ENV.delete(k) }
+       HIVE_TUI_FAKE_TRAP_INT HIVE_TUI_FAKE_BLOCK HIVE_TUI_FAKE_PID_FILE].each { |k| ENV.delete(k) }
   end
 
   def teardown
     %w[HIVE_TUI_FAKE_EXIT HIVE_TUI_FAKE_STDOUT HIVE_TUI_FAKE_STDERR
-       HIVE_TUI_FAKE_TRAP_INT HIVE_TUI_FAKE_BLOCK].each { |k| ENV.delete(k) }
+       HIVE_TUI_FAKE_TRAP_INT HIVE_TUI_FAKE_BLOCK HIVE_TUI_FAKE_PID_FILE].each { |k| ENV.delete(k) }
     Hive::Tui::SubprocessRegistry.clear
   end
 
@@ -239,7 +239,7 @@ class TuiSubprocessDispatchBackgroundTest < Minitest::Test
   def setup
     Hive::Tui::SubprocessRegistry.clear
     %w[HIVE_TUI_FAKE_EXIT HIVE_TUI_FAKE_STDOUT HIVE_TUI_FAKE_STDERR
-       HIVE_TUI_FAKE_TRAP_INT HIVE_TUI_FAKE_BLOCK].each { |k| ENV.delete(k) }
+       HIVE_TUI_FAKE_TRAP_INT HIVE_TUI_FAKE_BLOCK HIVE_TUI_FAKE_PID_FILE].each { |k| ENV.delete(k) }
     @messages = []
     @messages_mutex = Mutex.new
     @dispatch = ->(msg) { @messages_mutex.synchronize { @messages << msg } }
@@ -247,7 +247,7 @@ class TuiSubprocessDispatchBackgroundTest < Minitest::Test
 
   def teardown
     %w[HIVE_TUI_FAKE_EXIT HIVE_TUI_FAKE_STDOUT HIVE_TUI_FAKE_STDERR
-       HIVE_TUI_FAKE_TRAP_INT HIVE_TUI_FAKE_BLOCK].each { |k| ENV.delete(k) }
+       HIVE_TUI_FAKE_TRAP_INT HIVE_TUI_FAKE_BLOCK HIVE_TUI_FAKE_PID_FILE].each { |k| ENV.delete(k) }
     Hive::Tui::SubprocessRegistry.clear
   end
 
@@ -315,18 +315,24 @@ class TuiSubprocessDispatchBackgroundTest < Minitest::Test
     # Two slow children, dispatched back-to-back. If `dispatch_background`
     # is truly non-blocking, both finish in ~max(t1, t2), not t1 + t2.
     ENV["HIVE_TUI_FAKE_BLOCK"] = "1"
-    pids_killed = []
-    pids_mutex = Mutex.new
+    pid_capture = Tempfile.new("hive-tui-background-pids")
+    pid_capture.close
+    ENV["HIVE_TUI_FAKE_PID_FILE"] = pid_capture.path
 
     Hive::Tui::Subprocess.dispatch_background([ FAKE_CHILD, "develop" ], dispatch: @dispatch)
     Hive::Tui::Subprocess.dispatch_background([ FAKE_CHILD, "review" ], dispatch: @dispatch)
 
-    # Kill any blocking child after a brief moment so the reapers can fire.
+    # Target only the children spawned by this test. This keeps the fixture
+    # portable to minimal hosts that do not provide procps/pgrep.
     killer = Thread.new do
-      sleep 0.3
-      `pgrep -f tui-fake-child`.split.each do |pid|
+      deadline = Time.now + 3.0
+      pids = []
+      until pids.length == 2 || Time.now > deadline
+        pids = File.readlines(pid_capture.path, chomp: true).reject(&:empty?)
+        sleep 0.02 if pids.length < 2
+      end
+      pids.each do |pid|
         Process.kill("TERM", pid.to_i)
-        pids_mutex.synchronize { pids_killed << pid.to_i }
       rescue Errno::ESRCH
         nil
       end
@@ -338,6 +344,8 @@ class TuiSubprocessDispatchBackgroundTest < Minitest::Test
     verbs = @messages.map(&:verb).sort
     assert_equal %w[develop review], verbs,
       "each dispatch must surface its own verb on completion (no cross-talk)"
+  ensure
+    pid_capture&.unlink
   end
 
   # ---- Verb caching from argv[1] ----
diff --git a/test/release/manifest_contract_test.rb b/test/release/manifest_contract_test.rb
new file mode 100644
index 00000000..45ad1adb
--- /dev/null
+++ b/test/release/manifest_contract_test.rb
@@ -0,0 +1,95 @@
+require "test_helper"
+require "json"
+require "json_schemer"
+require "open3"
+require "digest"
+
+class ReleaseManifestContractTest < Minitest::Test
+  include HiveTestHelper
+
+  ROOT = File.expand_path("../..", __dir__)
+
+  def test_package_release_emits_valid_digest_and_metadata
+    with_tmp_dir do |dir|
+      build = File.join(dir, "build")
+      dist = File.join(dir, "dist")
+      FileUtils.mkdir_p(build)
+      File.write(File.join(build, "hive-linux-x86_64"), "#!/bin/sh\necho 0.1.0\n")
+      File.chmod(0o755, File.join(build, "hive-linux-x86_64"))
+      File.write(File.join(build, "hive-linux-x86_64.spdx.json"), "{}\n")
+
+      _out, err, status = Open3.capture3(
+        { "HIVE_RELEASE_REPOSITORY" => "example/hive" },
+        File.join(ROOT, "scripts", "package-release"),
+        "--version", "0.1.0",
+        "--build-dir", build,
+        "--dist-dir", dist
+      )
+      assert status.success?, err
+      manifest = JSON.parse(File.read(File.join(dist, "release-manifest.json")))
+      schema = JSONSchemer.schema(JSON.parse(File.read(File.join(ROOT, "packaging/release-manifest.schema.json"))))
+      assert_empty schema.validate(manifest).to_a
+      target = manifest.fetch("targets").first
+      archive = File.join(dist, target.fetch("asset"))
+      assert_equal Digest::SHA256.file(archive).hexdigest, target.fetch("sha256")
+      assert_equal File.size(archive), target.fetch("size")
+      assert_equal %w[install.sh uninstall-shell.sh],
+                   manifest.fetch("shell_assets").map { |row| row.fetch("asset") }.sort
+      manifest.fetch("shell_assets").each do |row|
+        path = File.join(dist, row.fetch("asset"))
+        assert_equal Digest::SHA256.file(path).hexdigest, row.fetch("sha256")
+        assert_equal File.size(path), row.fetch("size")
+      end
+    end
+  end
+
+  def test_non_semver_is_rejected
+    _out, _err, status = Open3.capture3(File.join(ROOT, "scripts", "build-release"), "--version", "main")
+    refute status.success?
+  end
+
+  def test_remote_verification_downloads_and_hashes_public_asset_bytes
+    with_tmp_dir do |dir|
+      build = File.join(dir, "build")
+      dist = File.join(dir, "dist")
+      remote = File.join(dir, "remote")
+      FileUtils.mkdir_p(build)
+      %w[darwin-arm64 linux-x86_64].each do |target|
+        path = File.join(build, "hive-#{target}")
+        File.write(path, "#!/bin/sh\necho 0.1.0\n")
+        File.chmod(0o755, path)
+      end
+      _out, err, status = Open3.capture3(
+        { "HIVE_RELEASE_REPOSITORY" => "example/hive" },
+        File.join(ROOT, "scripts", "package-release"),
+        "--version", "0.1.0",
+        "--build-dir", build,
+        "--dist-dir", dist
+      )
+      assert status.success?, err
+      FileUtils.cp_r(dist, remote)
+
+      manifest_path = File.join(dist, "release-manifest.json")
+      manifest = JSON.parse(File.read(manifest_path))
+      (manifest.fetch("targets") + manifest.fetch("shell_assets")).each do |row|
+        row["url"] = "file://#{File.join(remote, row.fetch('asset'))}"
+      end
+      File.write(manifest_path, JSON.pretty_generate(manifest))
+
+      _out, err, status = Open3.capture3(
+        File.join(ROOT, "scripts", "verify-release"),
+        "--manifest", manifest_path,
+        "--remote"
+      )
+      assert status.success?, err
+
+      File.open(File.join(remote, manifest.fetch("targets").first.fetch("asset")), "ab") { |file| file << "tampered" }
+      _out, _err, status = Open3.capture3(
+        File.join(ROOT, "scripts", "verify-release"),
+        "--manifest", manifest_path,
+        "--remote"
+      )
+      refute status.success?
+    end
+  end
+end
diff --git a/test/test_helper.rb b/test/test_helper.rb
index d251d52b..65aec42b 100644
--- a/test/test_helper.rb
+++ b/test/test_helper.rb
@@ -70,13 +70,22 @@ module HiveTestHelper
 
   def with_tmp_global_config
     dir = Dir.mktmpdir("hive-global")
-    old = ENV["HIVE_HOME"]
+    env_keys = %w[
+      HIVE_HOME XDG_CONFIG_HOME XDG_DATA_HOME XDG_STATE_HOME
+      XDG_CACHE_HOME XDG_RUNTIME_DIR
+    ]
+    old = env_keys.to_h { |key| [ key, ENV[key] ] }
     ENV["HIVE_HOME"] = dir
+    ENV["XDG_CONFIG_HOME"] = File.join(dir, "xdg-config")
+    ENV["XDG_DATA_HOME"] = File.join(dir, "xdg-data")
+    ENV["XDG_STATE_HOME"] = File.join(dir, "xdg-state")
+    ENV["XDG_CACHE_HOME"] = File.join(dir, "xdg-cache")
+    ENV["XDG_RUNTIME_DIR"] = File.join(dir, "xdg-runtime")
     File.write(File.join(dir, "config.yml"), { "registered_projects" => [] }.to_yaml)
     begin
       yield(dir)
     ensure
-      ENV["HIVE_HOME"] = old
+      old.each { |key, value| value ? ENV[key] = value : ENV.delete(key) }
       # Same race-tolerant cleanup as `with_tmp_dir`: tests inside this
       # tmpdir invoke `hive`/git subprocesses that can leave the tree
       # mid-rename.
